let exemple=
[|[|90;0;0;0;0;0;0;0|];
  [|0;9;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|]|];;
  
let exemple2=
[|[|100;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;5;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|];
  [|0;0;0;0;0;0;0;0|]|];;

let saut_de_ligne = 550 ;;
               
let zig_zag m l =
  let n=ref 0 and element=ref m.(0).(0) in
  for d=1 to 14 do
    let debut=max (d-7) 0 in
    if (d mod 2)=0 then 
      ( for x=debut to (d-debut) do
         let y=m.(x).(d-x) in
        if y=0 then n:=!n+1 else ( l:=(!n)::(!element::!l); n:=0; element:=y ; )
        done;)
    else
      ( for x=(d-debut) downto debut do
         let y=m.(x).(d-x) in
        if y=0 then n:=!n+1 else ( l:=(!n)::(!element::!l); n:=0; element:=y ; )
        done;)
  done;
  if !n=0 then l:=saut_de_ligne::!l else l:=saut_de_ligne::(!n)::(!element::!l) ;;
  
exception Erreur ;;

let dezig_zag liste =
  let m=make_matrix 8 8 0 and n = ref 0 in
try 
  for d=0 to 14 do
  let debut = max (d-7) 0 in
  if (d mod 2)=0 then 
  ( for x=debut to (d-debut) do
    if !n=0 then begin
                  match !liste with
                  | x::_ when x=saut_de_ligne -> raise Erreur
                  | e::(n1::l1) -> m.(x).(d-x) <- e; n:=n1; liste := l1 ;
                  | _-> failwith "Erreur dans DeZigZag" ; end
            else n:= !n -1;
    if !liste=[] then failwith "Erreur 2"
    done; )
    else
  ( for x=(d-debut) downto debut do
    if !n=0 then begin
                  match !liste with
                  | x::_ when x=saut_de_ligne -> raise Erreur
                  | e::(n1::l1) -> m.(x).(d-x) <- e; n:=n1; liste := l1 ;
                  | _-> failwith "Erreur dans DeZigZag" ; end
            else n:= !n-1;
    if !liste=[] then failwith "Erreur 2" 
    done; )
done; liste := tl !liste; m;
with Erreur -> liste := tl !liste; m ;;

let zig () =
  let l = ref [] in
  zig_zag exemple l;
  zig_zag exemple2 l ;
  l := rev !l ;
  let m = dezig_zag l in 
   !l ;;